# Standard modules
from os import sep
import os
from os.path import dirname, basename
from os import mkdir, access, F_OK
from os.path import join
from anuga.utilities.polygon import read_polygon
from shutil import copy
import time
import sys
# Related major packages
from anuga.shallow_water.data_manager import get_maximum_inundation_data
from anuga.shallow_water.data_manager import csv2polygons

# Application specific imports
from setup_model import project  # Definition of file names and polygons
import csv
directory = project.output_folder

time_dir1 = '20090505_150430_run_final_0.8_58292_None_kvanputt'
time_dir2 = '20090505_150517_run_final_0_58292_None_kvanputt'
time_dir3 = '20090505_150711_run_final_0_58280_None_kvanputt'
time_dir4 = '20090505_150805_run_final_0.8_58280_None_kvanputt'
time_dir5 = '20090505_151322_run_final_0.8_64477_None_kvanputt'
time_dir6 = '20090505_151447_run_final_0_64477_None_kvanputt'

time_dirs = [time_dir1, time_dir2, time_dir3, time_dir4, time_dir5, time_dir6]

polygons, values = csv2polygons(project.images)
print 'Creating %d highest runup' % len(polygons)

area_dictionary = {}
for id in polygons:
    area_dictionary[values[id]] = polygons[id] 

for time_dir in time_dirs:
    print 'time_dir ',time_dir
    basename = join(directory, time_dir, project.scenario_name)

    out_file = basename+'_runup.csv'
    output_file = open(out_file, 'w')
    s = 'area,q,x,y\n' 
    output_file.write(s)
     

    for which_area in values.itervalues():
        print 'which_area = %s' % which_area
        polygon = area_dictionary[which_area]
        
        q, loc = get_maximum_inundation_data(basename+'.sww',
                                             polygon=polygon, verbose=True)

        print '%s, %.6f, %.6f, %.6f\n' %(str(which_area), q, loc[0],loc[1])
        s = '%s, %.6f, %.6f, %.6f\n' %(str(which_area), q, loc[0],loc[1])

        output_file.write(s)

        print 'output file printed to: %s' %out_file
    output_file.close()
